#RequireAdmin
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\Includes\EliteIcon.ico
#AutoIt3Wrapper_Outfile_x64=ED_Runner.exe
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Description=ED:Runner 2.1.0
#AutoIt3Wrapper_Res_Fileversion=2.1.0.0
#AutoIt3Wrapper_Res_ProductVersion=2.1.0
#AutoIt3Wrapper_Res_LegalCopyright=Turranius (c) 2016-2018
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/mo
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#cs
	2.1:
	* Joystick_Test.exe improved codewise. Added version and architechture to the title as well.
	* If only one joystick was defined and it was not JoyID:0, it might crash when trying to detect movement if focus was lost. Fixed.
	* Added the ability to define parameters to RunPrograms applications. Just add another = after the .exe with the args you want. Example:
	  VoiceAttack=C:\Program Files (x86)\VoiceAttack\VoiceAttack.exe=-reverseprofilepriority
	  Or if you want multiple args, just use a space
	  VoiceAttack=C:\Program Files (x86)\VoiceAttack\VoiceAttack.exe=-reverseprofilepriority -listeningon

	2.0:
	* JoystickID can now take a range of Controller IDs to monitor instead of just one. The default is still only one ID, but you can specify a range with, for example, 0-2 to monitor
	  your first 3 controllers for movement. Observe that the range MUST start with 0.
	  This will probably make it a little slower to react to movement. If you specify more than the number of controllers you have, nothing bad will happen. It'll just take even longer.
      Had to rewrite large portions of the program for this to work so it suits it well to be called 2.0.

	* Added MonitorDelay option to the Extras section. This controls how long to wait, in MS, between checking the joystick for movement when the game is not the active window.
	  The default is 100 MS (Same as old versions) which makes it very quick to react to movements, but it might also take some CPU (Check task manager when game is not active).
	  If you think ED:Runner takes too much CPU, try raising it a bit (start with 200).
	  Setting it to 0 will make it mega responsive, but it will then take 8% CPU on an overclocked Intel 8700k ... Plus it might make it hard to break the JoyTolerance when it checks
	  that often.

	* New Joystick_Test program that shows all controllers at once (well, 8 of them).

	* Compiled as x64 instead of x86. No more x86 support (As if anyone use that with VR anyway...)

	1.9:
	* ED:Runner is no longer paused when talking, with the help of a new "ED_Speak.exe" executable. That will do the talking while the main program keeps running instead of waiting
	  for it to finish chatting. Some messages will still pause ("ED Start") and some will abort any current talking going on ("Game refocused" for example).

	* Added DoubleClickGameWindowDelayTune (TRUE/FALSE/RESET) to the Extras section. If TRUE, will give two beeps if DoubleClickGameWindowDelay is enabled, to help you fine tune the
	  DoubleClickGameWindowDelay value you need to abort the intro at the best possible time.
	  The first beep when the DoubleClickGameWindowDelay starts ... delaying and another higher beep when it actually clicks the game window.

	  If you have voices off and/or the ""Reset Headset"" voice off, it will also give another, slightly higher pitched beep 1 second before clicking the ResetHeadSet button, if
	  you have that enabled.
	  So you know when to look straight ahead before resetting the headset position, even with voices disabled.

      If you have no voices enabled for "Reset Headset" but always wants this second beep to remind you to look straight ahead, set DoubleClickGameWindowDelayTune to RESET and it
	  will always (only) beep one second before resetting the headset.

	* DoubleClickGameWindowDelay default value increased to 8 seconds. Seems right for my system. Can probably do with 7 seconds but 8 should be a better match for more people I guess.

	* Removed the "Double left clicking again in game window." action when DoubleClickGameWindowDelay is enabled. No reason for it anymore. Saves a second on startup time.

	1.8:
	* Reverted the WinTitleMatchMode change done in 1.7. Some people seems to have problems with "exact" match as it does not detect the game window when its running.
	  Changed the default back to "Match the title from the start" mode but also made it an option as I like to have it in "Exact title match" mode.
	  So added option WinTitleMatchMode in the extras section of the INI.
	* Added option LaunchProgramsWhenGameFound to the Extras section. If TRUE, LaunchPrograms are only executed once the game is found running. If FALSE (default), LaunchPrograms are
	  started when ED Runner starts (As they did pre 1.6). If this is set to FALSE, CloseLaunchPrograms will always be set to FALSE as well (or it will just close the program again..)
	* LaunchPrograms can now be "remmed out" with a # in front of them. The two default programs added to the default INI on first startup are both remmed out by default now.

	1.7:
	* Added CloseLaunchPrograms=FALSE to INI. Setting this to TRUE will also close the programs started with LaunchPrograms, providing ED:Runner was the one that started it (wont kill
	  anything if all programs in LaunchPrograms were already running when the game is detected as running).
	* WinTitleMatchMode changed. It now requires the exact names in EliteWindowTitle and LaunchPrograms. Previously it was partial match which could mess it up.
	* Fixed a potential crash at startup if it had not checked the defined controller for at least one loop already (rare occurance).
	* Removed "Activating Game" in the Voice section from the INI. Not used.
	* Added option OnlySwitchOnGameClosed to the AudioDeviceSettings section. When set to TRUE, it will not switch audio device when game focus is lost, only on game open, close.

	1.6:
	* If enabled, Output Sound Device should now always be from the VRAudioDevice if configured. It is only switched to NormalAudioDevice after elite is dead or lost focus and only after it
	  finished saying what it should. Previously, you lost some messages in the VRAudioDevice as it got set to NormalAudioDevice too soon.
	* If enabled, on startup, if the game is not running, the output device is set to the NormalAudioDevice If the game is running, its set to the VRAudioDevice device.
	* If enabled, ProgramLaunch programs are now only launched once the game is detected and is checked on every restart of the game.
	* General:ResetHeadSet & Voice:Reset Headset added to press a key to reset the headset on start of the game (not when refocusing).
	* Example INI created on first launch (if no INI exists) for those who want a simple program that just monitors the joystick and do not care about all the other fluff.
	* INI file notes at the bottom updated and cleaned up a bit. Only applies if you start from scratch or delete your current INI so a new one is created.
	* If enabled, the DoubleClickGameWindowDelay function to skip the intro now sets the game window to AlwaysOnTop and activates it an extra time just to be sure that it does not try and
	  click in any of the possible programs launched with ProgramLaunch. Sometimes they pop up above the game window.
	* If you accidentally hit your Windows Key or otherwise bring up your start menu, ED:Runner will fail to re activate the game window. It will detect the problem and if so, press ESC once
	  to first close the start menu before trying again.
	* Program will no longer be paused automatically when clicking its traybar icon.
	* Added ManualAudioDeviceKey in the General INI file settings. This sets a hotkey that will manually switch between VRAudioDevice and NormalAudioDevice, if those two are defined.
	* Added NoAutomaticAudioSwitching to the General INI file settings. Setting this to TRUE will disable the automatic audio switcher. Useful if you only want to use the ManualAudioDeviceKey above
	  to switch between the audio devices.
#ce

TraySetToolTip("ED:Runner starting")

#include <Misc.au3>
#include <File.au3>
#include <Process.au3>
;#include <WindowsConstants.au3>

Opt('SendKeyDownDelay', 50) ; We need to hold keypresses down a bit or they wont register with that game.
Opt("MouseClickDownDelay", 20) ; Same here. Click a bit slower with the mouse.
Opt("TrayAutoPause", 0) ; Do not pause automatically when clicking icon in traybar.
OnAutoItExitRegister("_Exit")

; Set up some global variables.
Global $IniFile = @ScriptDir & "\ED_Runner.ini"
Global $IniFileExample1 = @ScriptDir & "\EXAMPLE Simple JoyMonitor.ini"
Global $CurrentlyActive = "Default Audio Device Currently Set"
Global $TrayTipTitle = "NONE"
Global $LastFocusStatus = "UNKNOWN"
Global $ManualSwitched = "FALSE"
Global $ActivateNOW = "FALSE"
Global $StartedSomethingInLaunchPrograms = "FALSE"

Dim $ProgressBar, $Progress1

; Include the nircmd.exe in the executable itself.
FileInstall("H:\Scripts_and_Such\Autoit_scripts\ED_Runner\Includes\nircmd.exe", @ScriptDir & "\nircmd.exe")

; Grab version
If @Compiled Then
	Global $Version = FileGetVersion(@ScriptName)
Else
	Global $Version = "Not compiled"
EndIf
ConsoleWrite("Loading version " & $Version & @CRLF)

; Read the INI file. If it does not exist, create it with default values.
If FileExists($IniFile) Then
	$JoyNum = IniRead($IniFile, "General", "JoystickID", "NA")
	$JoyMonitor = IniRead($IniFile, "General", "JoyMonitor", "NA")
	$JoyTolerance = IniRead($IniFile, "General", "JoyTolerance", "0")
	$EliteWindowTitle = IniRead($IniFile, "General", "EliteWindowTitle", "Elite - Dangerous (CLIENT)")
	$DoubleClickGameWindowDelay = IniRead($IniFile, "General", "DoubleClickGameWindowDelay", "NA")
	$ResetHeadSet = IniRead($IniFile, "General", "ResetHeadSet", "NA")

	$VRAudioDevice = IniRead($IniFile, "AudioDeviceSettings", "VRAudioDevice", "NA")
	$NormalAudioDevice = IniRead($IniFile, "AudioDeviceSettings", "NormalAudioDevice", "NA")
	$ManualAudioDeviceKey = IniRead($IniFile, "AudioDeviceSettings", "ManualAudioDeviceKey", "NA")
	$NoAutomaticAudioSwitching = IniRead($IniFile, "AudioDeviceSettings", "NoAutomaticAudioSwitching", "TRUE")
	$OnlySwitchOnGameClosed = IniRead($IniFile, "AudioDeviceSettings", "OnlySwitchOnGameClosed", "FALSE")

	$EnableSounds = StringUpper(IniRead($IniFile, "Voice", "Enable Speech", "FALSE"))
	$VoiceRate = StringUpper(IniRead($IniFile, "Voice", "Voice Rate", "0"))
	$VoiceEDStart = IniRead($IniFile, "Voice", "ED Start", "NA")
	$VoiceVRActive = IniRead($IniFile, "Voice", "VR Audio Active", "NA")
	$VoiceNormalActive = IniRead($IniFile, "Voice", "Normal Audio Active", "NA")
	$VoiceLostFocus = IniRead($IniFile, "Voice", "Lost focus", "NA")
	$VoiceGameFound = IniRead($IniFile, "Voice", "Game found", "NA")
	$VoiceGameRefocused = IniRead($IniFile, "Voice", "Game refocused", "NA")
	$VoiceGameNotFound = IniRead($IniFile, "Voice", "Game not found", "NA")
	$VoiceResetHeadSet = IniRead($IniFile, "Voice", "Reset Headset", "NA")

	Global $LaunchProgramsArray = IniReadSection($IniFile, "LaunchPrograms")

	Global $PriorityArray = IniReadSection($IniFile, "Priority")

	$ExtraJoyDebugValues = IniRead($IniFile, "Extras", "ExtraJoyDebugValues", "FALSE")
	$WinTitleMatchMode = IniRead($IniFile, "Extras", "WinTitleMatchMode", "1")
	$LaunchProgramsWhenGameFound = IniRead($IniFile, "Extras", "LaunchProgramsWhenGameFound", "FALSE")
	$CloseLaunchPrograms = IniRead($IniFile, "Extras", "CloseLaunchPrograms", "FALSE")
	$DoubleClickGameWindowDelayTune = IniRead($IniFile, "Extras", "DoubleClickGameWindowDelayTune", "FALSE")
	$MonitorDelay = IniRead($IniFile, "Extras", "MonitorDelay", "100")

	If StringUpper($VRAudioDevice) = "DISABLED" Then
		$VRAudioDevice = "NA"
	EndIf
	If StringUpper($NormalAudioDevice) = "DISABLED" Then
		$NormalAudioDevice = "NA"
	EndIf

	; Quick test to verify new INI structure that changed in 1.6
	Local $TESTNormalAudioDevice = IniRead($IniFile, "General", "NormalAudioDevice", "NOT_SET")
	If $TESTNormalAudioDevice <> "NOT_SET" Then
		MsgBox(16, "New INI Structure", "The ini file structure changed in version 1.6. You should remove/rename your current ED_Runner.ini file and restart ED:Runner for it to be re created. Exiting.", 30)
		Exit
	EndIf

	If $LaunchProgramsWhenGameFound = "FALSE" Then
		If $CloseLaunchPrograms = "TRUE" Then
			ConsoleWrite("Changing CloseLaunchPrograms to FALSE as LaunchProgramsWhenGameFound is FALSE" & @CRLF)
			$CloseLaunchPrograms = "FALSE"
		EndIf
	EndIf

Else

	If Not FileExists($IniFileExample1) Then
		IniWrite($IniFileExample1, "General", "JoystickID", "? - Run the Joystick_Test programs to set this.")
		IniWrite($IniFileExample1, "General", "JoyMonitor", "1,2,3,6,7")
		IniWrite($IniFileExample1, "General", "JoyTolerance", "200")
		IniWrite($IniFileExample1, "General", "EliteWindowTitle", "Elite - Dangerous (CLIENT)")
		FileWriteLine($IniFileExample1, "")
		FileWriteLine($IniFileExample1, "")
		FileWriteLine($IniFileExample1, "If you simply want to monitor the joystick to refocus the game window then this is all")
		FileWriteLine($IniFileExample1, "you need in your ini file. For you who do not care for the other options.")
	EndIf

	IniWrite($IniFile, "General", "JoystickID", "0")
	IniWrite($IniFile, "General", "JoyMonitor", "1,2,3,6,7")
	IniWrite($IniFile, "General", "JoyTolerance", "200")
	IniWrite($IniFile, "General", "EliteWindowTitle", "Elite - Dangerous (CLIENT)")

	IniWrite($IniFile, "General", "DoubleClickGameWindowDelay", "8")
	IniWrite($IniFile, "General", "ResetHeadSet", "{F12}")

	FileWriteLine($IniFile, "")

	IniWrite($IniFile, "AudioDeviceSettings", "VRAudioDevice", "HeadPhones")
	IniWrite($IniFile, "AudioDeviceSettings", "NormalAudioDevice", "Speakers")
	IniWrite($IniFile, "AudioDeviceSettings", "ManualAudioDeviceKey", "!{PGUP}")
	IniWrite($IniFile, "AudioDeviceSettings", "NoAutomaticAudioSwitching", "FALSE")
	IniWrite($IniFile, "AudioDeviceSettings", "OnlySwitchOnGameClosed", "FALSE")

	FileWriteLine($IniFile, "")
	IniWrite($IniFile, "LaunchPrograms", "# E:D Market Connector", "C:\Program Files (x86)\EDMarketConnector\EDMarketConnector.exe")
	IniWrite($IniFile, "LaunchPrograms", "# VoiceAttack", "C:\Program Files (x86)\VoiceAttack\VoiceAttack.exe")

	FileWriteLine($IniFile, "")

	IniWrite($IniFile, "Voice", "Enable Speech", "True")
	IniWrite($IniFile, "Voice", "Voice Rate", "0")
	IniWrite($IniFile, "Voice", "ED Start", "E D runner starting")
	IniWrite($IniFile, "Voice", "VR Audio Active", "<VRAudioDevice> active")
	IniWrite($IniFile, "Voice", "Normal Audio Active", "<NormalAudioDevice> active")
	IniWrite($IniFile, "Voice", "Lost focus", "Lost Elite focus. Monitoring joystick <JoyID>")
	IniWrite($IniFile, "Voice", "Game found", "Game found. Activating")
	IniWrite($IniFile, "Voice", "Game refocused", "Refocusing")
	IniWrite($IniFile, "Voice", "Game not found", "Game not found. Idling")
	IniWrite($IniFile, "Voice", "Reset Headset", "Look straight ahead")
	FileWriteLine($IniFile, "")

	IniWrite($IniFile, "Priority", "EliteDangerous64.exe", "HIGH")
	IniWrite($IniFile, "Priority", "WatchDog64.exe", "LOW")

	FileWriteLine($IniFile, "")

	IniWrite($IniFile, "Extras", "ExtraJoyDebugValues", "FALSE")
	IniWrite($IniFile, "Extras", "WinTitleMatchMode", "1")
	IniWrite($IniFile, "Extras", "LaunchProgramsWhenGameFound", "FALSE")
	IniWrite($IniFile, "Extras", "CloseLaunchPrograms", "FALSE")
	IniWrite($IniFile, "Extras", "DoubleClickGameWindowDelayTune", "FALSE")
	IniWrite($IniFile, "Extras", "MonitorDelay", "100")


	FileWriteLine($IniFile, "")
	FileWriteLine($IniFile, "[Notes below here]")

	FileWriteLine($IniFile, "JoystickID:")
	FileWriteLine($IniFile, "Run the Joystick_Test program and check which controllers are identified as which IDs.")
	FileWriteLine($IniFile, "Set the number of the working controller as JoystickID above. Make sure that the Joystick_Test program")
	FileWriteLine($IniFile, "also reacts when it is NOT focused. If it stops reacting when not in focused (active window), see")
	FileWriteLine($IniFile, "the ReadMe.txt in the Xbox_Controller_Drivers folder, also included.")
	FileWriteLine($IniFile, "If you have multiple controllers you want to monitor, you can enter a range here, starting from 0.")
	FileWriteLine($IniFile, "For example: 0-3 will monitor your first 4 controllers.")
	FileWriteLine($IniFile, "If you type more IDs then you have controllers, nothing bad will happen. It will just slow it more.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "JoyMonitor:")
	FileWriteLine($IniFile, "When you find the program/number showing your joystick values, take note of which numbers change without")
	FileWriteLine($IniFile, "you moving anything at all. Some will most likely. The ""JoyMonitor"" setting defines which ones you WANT")
	FileWriteLine($IniFile, "to monitor, comma separated. So, if you see that number 4 and 5 are changing numbers even when you do not")
	FileWriteLine($IniFile, "move the joystick, do not include those numbers here. Valid numbers are 1-7 where 7 is the buttons on the controller.")
	FileWriteLine($IniFile, "If they only change a little bit, you can still use them with the JoyTolerance setting below though.")
	FileWriteLine($IniFile, "If you do NOT want to monitor the joystick at all, set ""JoyMonitor"" and/or ""JoystickID"" to ""NA"" or remove the line.")
	FileWriteLine($IniFile, "Please note that this setting applies to all different JoystickIDs set above if you've specified more then one JoystickID.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "JoyTolerance:")
	FileWriteLine($IniFile, "The numbers you see when running the joytest program range from 0 to 65535. Sometimes, just typing on your keyboard will")
	FileWriteLine($IniFile, "cause the joystick X or Y to move a few points. This sets a tolerance to that, so setting this at 100 will not activate")
	FileWriteLine($IniFile, "the Elite window if the movement is less that 100 points.")
	FileWriteLine($IniFile, "If you set this too high, you need to make hard and quick movements to actually trigger the Elite window activation...")
	FileWriteLine($IniFile, "This does NOT apply on JoyMonitor 7, if you have that enabled in JoyMonitor above, as that is the buttons and the fire")
	FileWriteLine($IniFile, "button goes from 0 to 1 when pressed, so you'll always get best result when pressing a joystick button.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "EliteWindowTitle:")
	FileWriteLine($IniFile, "The ""EliteWindowTitle"" setting is the title of the Elite game window. You should not need to change it but I've")
	FileWriteLine($IniFile, "added it here anyway if it changes in the future, or use this program for any other game.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "DoubleClickGameWindowDelay:")
	FileWriteLine($IniFile, "Double left click in the game window, when it is detected after being gone or just started, after this many seconds.")
	FileWriteLine($IniFile, "This gets rid of the Elite Dangerous intro quicker. 8 seconds is enough for me but if it does not double click, raise it.")
	FileWriteLine($IniFile, "If it waits to long (Elite intro runs on for a while), lower it. Set to NA to disable it.")
	FileWriteLine($IniFile, "Have a look at the DoubleClickGameWindowDelayTune setting further down if you need help tuning it.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "ResetHeadSet:")
	FileWriteLine($IniFile, "Only works if DoubleClickGameWindowDelay is enabled above. It will simply press a button for you after DoubleClickGameWindowDelay")
	FileWriteLine($IniFile, "has done its thing. You define the key to press here. See: https://www.autoitscript.com/autoit3/docs/functions/Send.htm")
	FileWriteLine($IniFile, "for valid keys to use. By default, resetting the headset is set to F12 in Elite, so its {F12} by default here.")
	FileWriteLine($IniFile, "Set to NA or remove the line from the INI to disable.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "VRAudioDevice and NormalAudioDevice:")
	FileWriteLine($IniFile, "If you do NOT want to switch the default Playback Device between the VR headset and normal speakers/headset, then")
	FileWriteLine($IniFile, "set VRAudioDevice and NormalAudioDevice to ""NA"" (without the quotes), or remove both lines from the INI file.")
	FileWriteLine($IniFile, "")
	FileWriteLine($IniFile, "If you do want to use it however, right click on the Volume Mixer in the traybar and select ""Playback devices"" or ""Open Sounds Settings"".")
	FileWriteLine($IniFile, "You may also check Control Panel / Sounds / Playback tab.")
	FileWriteLine($IniFile, "Check the names of the two devices you want to switch between. My normal speakers are called ""Speakers"" and")
	FileWriteLine($IniFile, "my Rift Audio is called ""HeadPhones"". Skip the part in the parenthesis, IE, if its ""Headphones (Rift Audio)"", just set ""Headphones"".")
	FileWriteLine($IniFile, "Set the names in the INI. When Elite is active, all audio will go to")
	FileWriteLine($IniFile, "the ""VRAudioDevice"" device. When Elite is not running or not active, the audio will go to the ""NormalAudioDevice""")
	FileWriteLine($IniFile, "This is the reason that ED:Runner wants to run as administrator if you're curious why it asks for it at startup (with UAC on).")
	FileWriteLine($IniFile, "The included nircmd.exe that is extracted in first run of ED:Runner is used for this process so leave it there.")
	FileWriteLine($IniFile, "If you are having problems finding the names to use, you can run ""nircmd.exe showsounddevices"" to get a hint of the name to use.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "ManualAudioDeviceKey:")
	FileWriteLine($IniFile, "This sets up a hotkey for manually switching between VRAudioDevice and NormalAudioDevice. The default is !{PGUP} which is")
	FileWriteLine($IniFile, "the same as Alt-PageUP. Check the link in ResetHeadSet above for instructions on how the keys work to change it.")
	FileWriteLine($IniFile, "Requires that both VRAudioDevice and NormalAudioDevice are set.")
	FileWriteLine($IniFile, "Set to NA or remove the line from the INI to disable.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "NoAutomaticAudioSwitching:")
	FileWriteLine($IniFile, "Setting this to TRUE will disable the automatic switching of audio devices set above. This is useful if you only")
	FileWriteLine($IniFile, "want to switch manually with ManualAudioDeviceKey above.")
	FileWriteLine($IniFile, "If your goal is to disable audio switching entirely, disable VRAudioDevice and NormalAudioDevice above instead.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "OnlySwitchOnGameClosed:")
	FileWriteLine($IniFile, "If this is set to TRUE, the audio device is only switched when the game starts or is closed. It will NOT change")
	FileWriteLine($IniFile, "when focus for the game is lost.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "LaunchPrograms:")
	FileWriteLine($IniFile, "Regarding the [LaunchPrograms] section, you can have other programs launched either when ED:Runner is launched or the game is detected.")
	FileWriteLine($IniFile, "Look at the examples here. The first part is the windows title of the program and after the ""="" is the full path to the")
	FileWriteLine($IniFile, "program to run. If the window title is not found it will launch it.")
	FileWriteLine($IniFile, "The programs will be rechecked if ED:Running detects that Elite is closed and opened again later, depending on your LaunchProgramsWhenGameFound and")
	FileWriteLine($IniFile, "CloseLaunchPrograms settings further down in the INI file.")
	FileWriteLine($IniFile, "If you require parameters to your exe, just add another = after the full path and then your parameters. Example:")
	FileWriteLine($IniFile, "VoiceAttack=C:\Program Files (x86)\VoiceAttack\VoiceAttack.exe=-reverseprofilepriority -listeningon")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "Voices:")
	FileWriteLine($IniFile, "This is the speech engine. It uses the default Microsoft Voice installed in your system (Vista and up).")
	FileWriteLine($IniFile, "NOTE: If you are on a x64 bit OS and can not get it to change voices, try running the 32bit version: C:\Windows\SysWOW64\Speech\SpeechUX\sapi.cpl")
	FileWriteLine($IniFile, "Enable Speech: Set to True to enable speech. False disables all of the below.")
	FileWriteLine($IniFile, "Voice Rate: Speed of voice. -20 to 20. 0 is ""normal"".")
	FileWriteLine($IniFile, "ED Start: This is spoken at the start of the program.")
	FileWriteLine($IniFile, "VR Audio Active: This is spoken when the audio device is switched to the VR headset.")
	FileWriteLine($IniFile, "Normal Audio Active: This is spoken when the audio device is switched to the Normal Audio device.")
	FileWriteLine($IniFile, "Activating Game: Spoken when Elite is reactivated due to joystick movement.")
	FileWriteLine($IniFile, "Lost focus: Spoken when the game window loses focus.")
	FileWriteLine($IniFile, "Game found: Spoken when game is detected on its start.")
	FileWriteLine($IniFile, "Game refocused: Spoken when ED:Runner automatically refocuses it due to joystick press.")
	FileWriteLine($IniFile, "Game not found: Spoken when the game is not detected to be running.")
	FileWriteLine($IniFile, "Reset Headset: Spoken just before it resets the headset, to remind you to look straight ahead.")
    FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "Any of the above spoken sentences can be set to NA to disable that single line or just put a # infront of it.")
	FileWriteLine($IniFile, "The following can be put in the voice text and will be translated to the actual setting:")
	FileWriteLine($IniFile, "<JoyID>, <JoyMonitor>, <JoyTolerance>, <VRAudioDevice>, <NormalAudioDevice> & <EliteWindowTitle>")
	FileWriteLine($IniFile, "The ""Activating Game"" setting can also take <JoyAxisMoved> to tell you what was moved.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "Priority:")
	FileWriteLine($IniFile, "If you want to make sure certain processes has a set priority, you can specify them here with either")
	FileWriteLine($IniFile, "HIGH, NORMAL or LOW. One process per row.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "ExtraJoyDebugValues:")
	FileWriteLine($IniFile, "Only used when running the debug version to find errors. If you find that the JoyTest program finds the joystick just fine")
	FileWriteLine($IniFile, "but ED:Runner just does not react to joystick movements in Elite, you can set this to TRUE and run the debug version. It will")
	FileWriteLine($IniFile, "then show the same values as the JoyTest program, for the enabled buttons to monitor (JoyMonitor above).")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "WinTitleMatchMode:")
	FileWriteLine($IniFile, "This decides how window titles are searched for. Affects EliteWindowTitle and LaunchPrograms.")
	FileWriteLine($IniFile, "1 = (default) Match the title from the start")
	FileWriteLine($IniFile, "2 = Match any substring in the title")
	FileWriteLine($IniFile, "3 = Exact title match")
	FileWriteLine($IniFile, "-1 to -3 = Case insensitive match according to the other type of match.")
	FileWriteLine($IniFile, "Most people will not need to touch this setting.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "LaunchProgramsWhenGameFound:")
	FileWriteLine($IniFile, "This affects programs started with LaunchPrograms. If set to TRUE, the LaunchPrograms are only started once the game window")
	FileWriteLine($IniFile, "is detected. If set to FALSE (Default), the LaunchPrograms are started when ED Runner is started.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "CloseLaunchPrograms:")
	FileWriteLine($IniFile, "When game is closed (gone), close any programs you have in the LaunchPrograms section. Set to TRUE to enable. FALSE by default.")
	FileWriteLine($IniFile, "Only active if LaunchProgramsWhenGameFound is TRUE.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "DoubleClickGameWindowDelayTune:")
	FileWriteLine($IniFile, "If you set this to TRUE, it will give you one beep when the ""DoubleClickGameWindowDelay"" pause starts and another, slighly")
	FileWriteLine($IniFile, "higher pitched beep as it clicks. This is to help you tune how long your ""DoubleClickGameWindowDelay"" should be")
	FileWriteLine($IniFile, "It also gives a slightly lower pitched beep 1 second before ""ResetHeadSet"" kicks in, if you have that enabled and no voice enabled for Reset Headset.")
	FileWriteLine($IniFile, "If you ONLY want it to beep on reset headset (to have it on permanently), set it to RESET and it will beep and wait one second")
	FileWriteLine($IniFile, "before resetting the headset. Again, the Reset Headset beep only works if ""Enable Speech"" is FALSE or ""Reset Headset""")
	FileWriteLine($IniFile, "is not active.")
	FileWriteLine($IniFile, "")

	FileWriteLine($IniFile, "MonitorDelay:")
	FileWriteLine($IniFile, "Here you set the delay in MS between checking controllers for movement when the game is not the active window.")
	FileWriteLine($IniFile, "The default is 100 MS between checking joystick coordinates to see if they change. If you want it faster / more responsive, lower the value.")
	FileWriteLine($IniFile, "If you think ED:Runner takes too much CPU, raise it (500 = 1/2 second), but it will then be slower to react and reactivate the game window.")
	FileWriteLine($IniFile, "If you set it 0, it takes 8% CPU on an overclocked i8700K....")

	MsgBox(0, $IniFile & " created", "INI file created and will now be opened in notepad. Please edit it, save and restart ED:Runner." & @CRLF & "Remember to scroll down the .ini file for instructions on each setting" & @CRLF & @CRLF & "Also, if you do not want all the fluff this program comes with, there is a simpler EXAMPLE ini file in the Debug folder. Simply rename it to ED_Runner.ini and copy it out of the Debug folder.")
	Run("Notepad.exe " & $IniFile)
	Exit
EndIf

; Check some INI values.
If $DoubleClickGameWindowDelay = "" Or $DoubleClickGameWindowDelay = "NA" Then
	If $ResetHeadSet <> "" And $ResetHeadSet <> "NA" Then
		MsgBox(16, "INI Warning", "ResetHeadSet is set but DoubleClickGameWindowDelay is disabled. Disabling the ResetHeadSet function as it is depending on DoubleClickGameWindowDelay for its delay etc. Will continue anyway but you should fix this.")
		ConsoleWrite("Warning. ResetHeadSet is set but DoubleClickGameWindowDelay is disabled. Disabling the ResetHeadSet function as it is depending on DoubleClickGameWindowDelay for its delay etc." & @CRLF)
	EndIf
EndIf

; Set up Autoit to only match on exact windows titles.
ConsoleWrite("WinTitleMatchMode is set to " & $WinTitleMatchMode & @CRLF)
Opt("WinTitleMatchMode", $WinTitleMatchMode) ;1=start, 2=subStr, 3=exact, -1 to -3=Nocase

; Process that does all the talking.
Func _Speak($Text)
	If $EnableSounds = "TRUE" Then
		If FileExists(@TempDir & "\ED_Speak.exe") Then
			ConsoleWrite("Voice: " & Chr(34) & $Text & Chr(34) & " to " & $CurrentlyActive & @CRLF)
			Run(@TempDir & "\ED_Speak.exe " & $VoiceRate & " " & Chr(34) & $Text & Chr(34))
		Else
			ConsoleWrite(@TempDir & "\ED_Speak.exe is not found. Setting $EnableSounds = FALSE" & @CRLF)
			MsgBox(16, "Error", @TempDir & "\ED_Speak.exe is not found. Disabling sounds.", 5)
			$EnableSounds = "FALSE"
		EndIf
	EndIf
EndFunc

; Set up which joysticks to monitor and verify that the number is correct.
If StringInStr($JoyNum, "-") Then; Does the defined Joynum contain a - ? If so, a range was specified.
	Local $TempArray = StringSplit($JoyNum, "-") ; Create a temporary array using - as splitter
	Global $JoyNumStart = $TempArray[1] ; Set the first joystick to monitor (should be 0 as we must start with that).
	If $JoyNumStart <> 0 Then; If the first number is NOT 0, error out.
		ConsoleWrite("STOP ERROR 1: Invalid JoystickID: " & $JoyNum & @CRLF)
		MsgBox(16, "INI Error 1", "JoystickID in the INI file must either be a single digit (Joystick number to monitor) or a range of IDs, starting from 0. Example ""0-2"" to monitor 3 joysticks total." & @CRLF & "Current setting: " & $JoyNum)
		Exit
	EndIf
	Global $JoyNumEnd = $TempArray[2]; Set the last joystick to monitor.
	ConsoleWrite("Start joystick: " & $JoyNumStart & @CRLF); Debug
	ConsoleWrite("End joystick: " & $JoyNumEnd & @CRLF); Debug
	Global $CordsArray[8][$JoyNumEnd +1]; Create the array and make enough rows to hold all joysticks.
	ConsoleWrite("Monitoring multiple joystick IDs: " & $JoyNum & @CRLF)
Else
	; No - in JoyNum so the INI file only contains one joystick ID to monitor. Just make a small array for that single joystick.
	Global $JoyNumStart = $JoyNum
	Global $JoyNumEnd = $JoyNum
	Global $CordsArray[8][$JoyNum+1]
	ConsoleWrite("Monitoring a single joystick ID: " & $JoyNum & @CRLF)
EndIf

; Verify that both start and end joystick IDs are numbers.. Error out otherwise.
If NOT StringIsDigit($JoyNumStart) or NOT StringIsDigit($JoyNumEnd) Then
	ConsoleWrite("STOP ERROR 2: Invalid JoystickID: '" & $JoyNum & "'" & @CRLF)
	MsgBox(16, "INI Error 2", "JoystickID in the INI file must either be a single digit (Joystick number to monitor) or a range of IDs, starting from 0. Example ""0-2"" to monitor 3 joysticks total." & @CRLF & "Current setting: " & Chr(34) & $JoyNum & Chr(34))
	Exit
EndIf

; Set up Speech
If $EnableSounds = "TRUE" Then
	ConsoleWrite("Setting up voice..." & @CRLF)
	If FileExists(@TempDir & "\ED_Speak.exe") Then
		FileDelete(@TempDir & "\ED_Speak.exe")
	EndIf
	FileInstall("H:\Scripts_and_Such\Autoit_scripts\ED_Runner\Includes\ED_Speak.exe", @TempDir & "\ED_Speak.exe")

	If $VoiceEDStart <> "NA" Then
		$Output = _Translate($VoiceEDStart)
		_Speak($Output)
		ProcessWaitClose("ED_Speak.exe", 20)

	EndIf
EndIf

; Here we check the audio device and switch between them, if enabled.
If $VRAudioDevice <> "NA" And $NormalAudioDevice <> "NA" Then
	If WinExists($EliteWindowTitle, "") Then
		If $CurrentlyActive <> "Device1" Then
			_EnableVRAudio()
		EndIf
	Else
		If $CurrentlyActive <> "Device2" Then
			_EnableNormalAudio()
		EndIf
	EndIf

	; Set up hotkey for manual switching.
	If $ManualAudioDeviceKey <> "" And $ManualAudioDeviceKey <> "NA" Then
		ConsoleWrite("Setting hotkey for manual audio switch: <" & $ManualAudioDeviceKey & ">" & @CRLF)
		HotKeySet($ManualAudioDeviceKey, "_SwitchAudio")
	EndIf
EndIf

; Just some debug.
ConsoleWrite("Joystick to monitor: " & Chr(34) & $JoyNum & Chr(34) & @CRLF)
ConsoleWrite("Joystick inputs to monitor: " & Chr(34) & $JoyMonitor & Chr(34) & @CRLF)
ConsoleWrite("Delay between controller checks: " & $MonitorDelay & " MS" & @CRLF)

; Verify MonitorDelay values.
If NOT StringIsDigit($MonitorDelay) Then
	ConsoleWrite("Error with MonitorDelay in INI file. Should be a number (100 default). Current value: " & $MonitorDelay & @CRLF)
	Exit
EndIf
If $MonitorDelay < 100 Then
	ConsoleWrite("WARNING: MonitorDelay below 100 is not recommended. Current value: " & $MonitorDelay & "MS" & @CRLF)
EndIf
If $MonitorDelay > 1000 Then
	ConsoleWrite("WARNING: MonitorDelay above 1000 is not recommended as its to slow to react to movement. Current value: " & $MonitorDelay & "MS" & @CRLF)
EndIf

; Setup some joystick stuff
Local $joy, $coor, $h, $s, $msg
$joy = _JoyInit()
$coord = _GetJoy($joy, 0); Kickstart joysticks by checking them once here.

; Set the traytip when hovering over the icon.
TraySetToolTip("ED:Runner")

; Setup the array of which joystick axis to monitor here, if enabled.
If $JoyMonitor <> "NA" Then
	$JoyMonitorArray = StringSplit($JoyMonitor, ",")
EndIf

; If $LaunchProgramsWhenGameFound = FALSE, we want to start the LaunchPrograms even though the game is not started. Run them here before entering the loop.
If $LaunchProgramsWhenGameFound = "FALSE" Then
	_LaunchPrograms()
EndIf

; Start the main loop that we'll stay in for as long as we run.
While 1

	; Here we keep the priorities in check
	_PriorityCheck()

	; Here is the joystick checks, if enabled. Only do this if Elite is actually running.
	If WinExists($EliteWindowTitle, "") And $JoyMonitor <> "NA" And $JoyNum <> "NA" Then

		; Voice outout if we had lost the game window (closed) but now its back. Also activate the game window quickly.
		If $LastFocusStatus = "NOTFOUND" Then
			; If $LaunchProgramsWhenGameFound = TRUE, we only want to launch programs when the game is started. Do so here.
			If $LaunchProgramsWhenGameFound = "TRUE" Then
				_LaunchPrograms() ; Launch programs again.
			EndIf

			WinActivate($EliteWindowTitle, "")
			ConsoleWrite("Game window found again. Activating it." & @CRLF)

			If $VRAudioDevice <> "NA" And $NormalAudioDevice <> "NA" Then
				If $CurrentlyActive <> "Device1" Then
					_EnableVRAudio()
				EndIf
			EndIf

			If $VoiceGameFound <> "NA" Then
				$Output = _Translate($VoiceGameFound)
				_Speak($Output)
				;ConsoleWrite("Voice: " & Chr(34) & $Output & Chr(34) & " to " & $CurrentlyActive & @CRLF)
			EndIf
			$LastFocusStatus = "FOUND"

			; Try and double click in the game window to get faster startup.
			If $DoubleClickGameWindowDelay <> "" And $DoubleClickGameWindowDelay <> "NA" Then
				Local $WinPos = WinGetPos($EliteWindowTitle, "")
				If IsArray($WinPos) Then
					ConsoleWrite("Found game window to double click at X:" & $WinPos[0] & " Y:" & $WinPos[1] & @CRLF)
					If $DoubleClickGameWindowDelayTune = "TRUE" Then
						Beep(400, 200)
					EndIf

					Sleep($DoubleClickGameWindowDelay * 1000)

					ConsoleWrite("Set " & $EliteWindowTitle & " to AlwaysOnTop to make sure we click it." & @CRLF)
					WinSetOnTop($EliteWindowTitle, "", 1) ; Set game window to Always On Top to make sure it pops up above any ProgramLaunch launched programs.
					WinActivate($EliteWindowTitle, "") ; Activate it just in case.

					ConsoleWrite("Double left clicking mouse in game window." & @CRLF)
					If $DoubleClickGameWindowDelayTune = "TRUE" Then
						Beep(500, 200)
					EndIf

					MouseClick("left", $WinPos[0] + $WinPos[2] / 2, $WinPos[1] + $WinPos[3] / 2, 2)
					Sleep(100)
					ConsoleWrite("Release AlwaysOnTop for " & $EliteWindowTitle & @CRLF)
					WinSetOnTop($EliteWindowTitle, "", 0) ; Remove the AlwaysOnTop flag for the game window.
				EndIf
				_ResetHeadSet() ; Reset headset
			EndIf
		EndIf

		; Make sure Elite is NOT the active window to start monitor the joystick. No reason to let it do that when Elite is active already.
		If Not WinActive($EliteWindowTitle, "") Then

			; Change name when hovering over the icon the traybar.
			If $TrayTipTitle <> "NOTACTIVE" Then
				TraySetToolTip("ED:Runner Game not active. Monitoring joystick")
				$TrayTipTitle = "NOTACTIVE"
			EndIf

			; ConsoleWrites are only shown when running the debug version / not compiled so we use it for debug.
			ConsoleWrite("Lost focus for " & $EliteWindowTitle & " - Monitoring joystick #" & $JoyNum & @CRLF)

			If $VoiceLostFocus <> "NA" Then

				; Make sure the next message (lost output), if on, is spoken in the VR headset.
				If $VRAudioDevice <> "NA" And $NormalAudioDevice <> "NA" Then
					If $CurrentlyActive <> "Device1" Then
						_EnableVRAudio()
					EndIf
				EndIf

				$Output = _Translate($VoiceLostFocus)
				_Speak($Output)
				;ConsoleWrite("Voice: " & Chr(34) & $Output & Chr(34) & " to " & $CurrentlyActive & @CRLF)
			EndIf

			If $VRAudioDevice <> "NA" And $NormalAudioDevice <> "NA" Then
				If $OnlySwitchOnGameClosed = "FALSE" Then
					If $CurrentlyActive <> "Device2" Then
						_EnableNormalAudio()
					EndIf
				Else
					ConsoleWrite("Lost game focus. Not switching audio device as OnlySwitchOnGameClosed is TRUE" & @CRLF)
				EndIf
			EndIf

			; Get the joystick coordinates once here before we start looping so we have something to compare with on the first loop.
			For $j = $JoyNumStart to $JoyNumEnd
				;ConsoleWrite("Prefilling coords for joy " & $j & @CRLF)
				$coord = _GetJoy($joy, $j)
				$CordsArray[0][$j] = $coord[0]
				$CordsArray[1][$j] = $coord[1]
				$CordsArray[2][$j] = $coord[2]
				$CordsArray[3][$j] = $coord[3]
				$CordsArray[4][$j] = $coord[4]
				$CordsArray[5][$j] = $coord[5]
				$CordsArray[6][$j] = $coord[6]
				$CordsArray[7][$j] = $coord[7]
				;_ArrayDisplay($CordsArray)
			Next
			$Lastcoord = $CordsArray; Save the new array to $Lastcoord array which we compare with.

			; Here is the actual monitoring thats running while Elite is NOT active.
			While Not WinActive($EliteWindowTitle, "")


				; While in this "not active" loop, check if the game is still running. Otherwise exit loop so it goes into the "long idle" loop instead.
				If Not WinExists($EliteWindowTitle, "") Then
					ExitLoop
				EndIf

				; Fill the array with the current joystick coordinates.
				If $ExtraJoyDebugValues = "TRUE" Then
					ConsoleWrite("Getting coords for joy " & $JoyNum & @CRLF)
				EndIf
				For $j = $JoyNumStart to $JoyNumEnd
					$coord = _GetJoy($joy, $j)
					$CordsArray[0][$j] = $coord[0]
					$CordsArray[1][$j] = $coord[1]
					$CordsArray[2][$j] = $coord[2]
					$CordsArray[3][$j] = $coord[3]
					$CordsArray[4][$j] = $coord[4]
					$CordsArray[5][$j] = $coord[5]
					$CordsArray[6][$j] = $coord[6]
					$CordsArray[7][$j] = $coord[7]
					;_ArrayDisplay($CordsArray)
				Next


				; For each defined joystick ID.
				For $j = $JoyNumStart to $JoyNumEnd
					; Go through each axis set up in the JoyMonitor setting from the ini and check if its the same now as the last loop.
					For $i = 1 To $JoyMonitorArray[0]
						Local $ActivateNOW = "FALSE"

						If $ExtraJoyDebugValues = "TRUE" Then
							ConsoleWrite("Joy " & $j & "/" & $JoyMonitorArray[$i] & " monitor value: " & $CordsArray[$JoyMonitorArray[$i]][$j] & " - last value:" & $Lastcoord[$JoyMonitorArray[$i]][$j] & @CRLF)
						EndIf

						; If the coordinates of the monitored axis is not the same as last time, the joystick was moved.
						; Special handling of joystick cords 7 as that is the buttons. They should not be affected by JoyTolerance at all.
						If $JoyMonitorArray[$i] = "7" Then
							If $CordsArray[$JoyMonitorArray[$i]][$j] <> $Lastcoord[$JoyMonitorArray[$i]][$j] Then
								$ActivateNOW = "TRUE"
							EndIf
							; Everything else, part from 7 (buttons) should be affected by JoyTolerance.
						Else
							If $CordsArray[$JoyMonitorArray[$i]][$j] < $Lastcoord[$JoyMonitorArray[$i]][$j] - $JoyTolerance Or $CordsArray[$JoyMonitorArray[$i]][$j] > $Lastcoord[$JoyMonitorArray[$i]][$j] + $JoyTolerance Then
								$ActivateNOW = "TRUE"
							EndIf
						EndIf

						If $ActivateNOW = "TRUE" Then
							; Activate the Elite game window and write some debug that is not shown when compiled really...
							WinActivate($EliteWindowTitle, "")
							ConsoleWrite("Movement on Joy " & $j & "/" & $JoyNumEnd & " - Activating " & $EliteWindowTitle & " - Now: " & $CordsArray[$JoyMonitorArray[$i]][$j] & " - Previous: " & $Lastcoord[$JoyMonitorArray[$i]][$j] & @CRLF)

							; If you accidentally open the start menu in Windows, you can not activate the window this way. Trying a different approach just to be safe.
							If Not WinActive($EliteWindowTitle, "") Then
								ConsoleWrite("Seems I can't focus on the game window. Trying again." & @CRLF)
								WinActivate($EliteWindowTitle, "")
								Sleep(20)
								If Not WinActive($EliteWindowTitle, "") Then
									ConsoleWrite("Nope, can not activate it. Possible that the start bar is up? Trying to press ESC once and then trying again." & @CRLF)
									Send("{ESC}")
									Sleep(20)
									WinActivate($EliteWindowTitle, "")
									If Not WinActive($EliteWindowTitle, "") Then
										ConsoleWrite("No, that did not work. Giving up.." & @CRLF)
									Else
										ConsoleWrite("That seems to have done the trick. All OK." & @CRLF)
									EndIf
								EndIf
							EndIf

							If $VRAudioDevice <> "NA" And $NormalAudioDevice <> "NA" Then
								If $CurrentlyActive <> "Device1" Then
									_EnableVRAudio()
								EndIf
							EndIf

							If $VoiceGameRefocused <> "NA" Then
								$Output = _Translate($VoiceGameRefocused)
								$Output = StringReplace($Output, "<JoyAxisMoved>", $JoyMonitorArray[$i])
								_Speak($Output)
								;ConsoleWrite("Voice: " & Chr(34) & $Output & Chr(34) & " to " & $CurrentlyActive & @CRLF)
							EndIf

							ExitLoop(2)
						EndIf
					Next
				Next
				; Some extra debug if enabled
				If $ExtraJoyDebugValues = "TRUE" Then
					ConsoleWrite("Joy check end" & @CRLF & @CRLF)
				EndIf

				Sleep($MonitorDelay)
				; Set the coordinates found this time to $Lastcoord so we can compare it on the next loop.
				;$Lastcoord = $coord
				$Lastcoord = $CordsArray
			WEnd

			; If we got here but $ActivateNOW is FALSE, we regained focus but not from the joystick movement...
			If $ActivateNOW = "FALSE" Then
				ConsoleWrite("Regained focus by external force..." & @CRLF)

				If $VRAudioDevice <> "NA" And $NormalAudioDevice <> "NA" Then
					If $CurrentlyActive <> "Device1" Then
						_EnableVRAudio()
					EndIf
				EndIf

				If $VoiceGameRefocused <> "NA" Then
					$Output = _Translate($VoiceGameRefocused)
					_Speak($Output)
					;ConsoleWrite("Voice: " & Chr(34) & $Output & Chr(34) & " to " & $CurrentlyActive & @CRLF)
				EndIf
			EndIf

		Else
			; Elite is the active window so just set the Traytip once.
			If $TrayTipTitle <> "ACTIVE" Then
				TraySetToolTip("ED:Runner - Game active. Idling")
				$TrayTipTitle = "ACTIVE"
			EndIf
			Sleep(1000) ; Extra sleep here while the game is active.
		EndIf
	Else
		; When we were detecting the game window, but now its lost, say this.
		If $LastFocusStatus = "FOUND" Or $LastFocusStatus = "UNKNOWN" Then
			ConsoleWrite("Lost game window. Long idle." & @CRLF)

			If $VRAudioDevice <> "NA" And $NormalAudioDevice <> "NA" Then
				If $CurrentlyActive <> "Device2" Then
					_EnableNormalAudio()
				EndIf
			EndIf

			If $VoiceGameNotFound <> "NA" Then
				$Output = _Translate($VoiceGameNotFound)
				_Speak($Output)
				;ConsoleWrite("Voice: " & Chr(34) & $Output & Chr(34) & " to " & $CurrentlyActive & @CRLF)
			EndIf

			$LastFocusStatus = "NOTFOUND"

			_CloseLaunchPrograms()
		EndIf
		; When the game is not running at all, set this traytip.
		If $TrayTipTitle <> "NOTFOUND" Then
			TraySetToolTip("ED:Runner - Game not running. 2 second idle")
			$TrayTipTitle = "NOTFOUND"
		EndIf
		Sleep(2000) ; Extra 2 second sleep here while the game is not running. No reason to check more often...
	EndIf

	; Sleep for half a second before looping again. This prevents the CPU from going wild.
	Sleep(500)

WEnd

; Functions below here.

Func _DebugMessageWait()
	ConsoleWrite("Hotkey disabled. Please wait for it to finish." & @CRLF)
EndFunc   ;==>_DebugMessageWait

; Function executed on manual switch of audio device.
Func _SwitchAudio()
	HotKeySet($ManualAudioDeviceKey, "_DebugMessageWait") ; Disable hotkey while this is running.
	$ManualSwitched = "TRUE"
	ConsoleWrite("ManualAudioDeviceKey triggered. Switching audio device" & @CRLF)
	If $CurrentlyActive = "Device1" Then
		_EnableNormalAudio()
	Else
		_EnableVRAudio()
	EndIf
	$ManualSwitched = "FALSE"
	HotKeySet($ManualAudioDeviceKey, "_SwitchAudio") ; Enable hotkey again.
EndFunc   ;==>_SwitchAudio

; Function for LaunchPrograms
Func _CloseLaunchPrograms()
	If $CloseLaunchPrograms = "TRUE" And $StartedSomethingInLaunchPrograms = "TRUE" Then
		; Launch any programs in [LaunchPrograms]. Check if we did get an array first...
		If IsArray($LaunchProgramsArray) Then
			; If the array have more then 0 entries, go on.
			If $LaunchProgramsArray[0][0] > "0" Then
				; For every entry in the array...
				For $i = 1 To $LaunchProgramsArray[0][0]
					; Set up the variables from the array. Easier to use this way.
					Local $TempFullPath = $LaunchProgramsArray[$i][1]
					Local $TempEXEWinTitle = $LaunchProgramsArray[$i][0]

					If NOT StringInStr($TempEXEWinTitle, "#", 0, 1, 1) Then
						; Split up the full path into different parts.
						Local $sDrive = "", $sDir = "", $sFileName = "", $sExtension = ""
						Local $aPathSplit = _PathSplit($TempFullPath, $sDrive, $sDir, $sFileName, $sExtension)

						; The file exists. Check the windows title. If it does not exist already...
						If WinExists($TempEXEWinTitle, "") And ProcessExists($sFileName & $sExtension) Then
							; Kill the program.
							ConsoleWrite(Chr(34) & $TempEXEWinTitle & Chr(34) & " (" & $sFileName & $sExtension & ") running. Closing it." & @CRLF)
							WinClose($TempEXEWinTitle)
						Else
							ConsoleWrite(Chr(34) & $TempEXEWinTitle & Chr(34) & " (" & $sFileName & $sExtension & ") not found. Ignoring stop." & @CRLF)
						EndIf
					Else
						ConsoleWrite("Ignoring CloseLaunchPrograms: " & $TempEXEWinTitle & @CRLF)
					EndIf
				Next
			EndIf
		EndIf
	EndIf
EndFunc   ;==>_CloseLaunchPrograms

; Function for LaunchPrograms
Func _LaunchPrograms()
	; Launch any programs in [LaunchPrograms]. Check if we did get an array first...
	If IsArray($LaunchProgramsArray) Then
		; If the array have more then 0 entries, go on.
		If $LaunchProgramsArray[0][0] > "0" Then
			; For every entry in the array...
			For $i = 1 To $LaunchProgramsArray[0][0]
				; Set up the variables from the array. Easier to use this way.
				Local $TempEXEWinTitle = $LaunchProgramsArray[$i][0]
				Local $TempFullPath = $LaunchProgramsArray[$i][1]

Local $Parameters = ""
If StringInStr($TempFullPath, "=") Then
	Local $TempArray = StringSplit($TempFullPath, "=")
	ConsoleWrite("LaunchPrograms reports EXE: " & Chr(34) & $TempArray[1] & Chr(34) & " with parameters " & Chr(34) & $TempArray[2] & Chr(34) & @CRLF)
	$TempFullPath = $TempArray[1]
	$Parameters = $TempArray[2]
EndIf

				If NOT StringInStr($TempEXEWinTitle, "#", 0, 1, 1) Then
					; Split up the full path into different parts. We need the workingdir from the full path when calling "run" further down.
					Local $sDrive = "", $sDir = "", $sFileName = "", $sExtension = ""
					Local $aPathSplit = _PathSplit($TempFullPath, $sDrive, $sDir, $sFileName, $sExtension)

					; Check that the file actually exists. Show an error message if it does not.
					If Not FileExists($sDrive & $sDir & $sFileName & $sExtension) Then
						MsgBox(16, "Failure on " & $TempEXEWinTitle, "The file" & @CRLF & $sDrive & $sDir & $sFileName & $sExtension & @CRLF & "was not found. Skipping.", 5)
					Else
						; The file exists. Check the windows title. If it does not exist already...
						If Not WinExists($TempEXEWinTitle, "") Then
							; Window was not found. Make sure the exe specified is not running either.
							If ProcessExists($sFileName & $sExtension) Then
								ConsoleWrite("Warning: Windows title: " & Chr(34) & $TempEXEWinTitle & Chr(34) & " was not found but there is a process running called " & Chr(34) & $sFileName & $sExtension & Chr(34) & @CRLF)
								MsgBox(16, "ED:Runner Warning", "Windows title: " & Chr(34) & $TempEXEWinTitle & Chr(34) & " was not found but there is a process running called " & Chr(34) & $sFileName & $sExtension & Chr(34) & ". Possibly dead process running or badly configured LaunchProgram?", 120)
							Else
								If $Parameters = "" Then
									; Run the program and log it in debug / not compiled mode.
									Local $Status = Run($sDrive & $sDir & $sFileName & $sExtension, $sDrive & $sDir)
									ConsoleWrite(Chr(34) & $TempEXEWinTitle & Chr(34) & " not found. Running: " & Chr(34) & $sDrive & $sDir & $sFileName & $sExtension & Chr(34) & " with workingdir: " & Chr(34) & $sDrive & $sDir & Chr(34) & " Status/PID: " & $Status & @CRLF)
									$StartedSomethingInLaunchPrograms = "TRUE"
								Else
									; Run the program with parameters and log it in debug / not compiled mode.
									Local $Status = Run($sDrive & $sDir & $sFileName & $sExtension & " " & $Parameters, $sDrive & $sDir)
									ConsoleWrite(Chr(34) & $TempEXEWinTitle & Chr(34) & " not found. Running: " & Chr(34) & $sDrive & $sDir & $sFileName & $sExtension & Chr(34) & " with parameters " & Chr(34) & $Parameters & Chr(34) & " and workingdir: " & Chr(34) & $sDrive & $sDir & Chr(34) & " Status/PID: " & $Status & @CRLF)
									$StartedSomethingInLaunchPrograms = "TRUE"
								EndIf
							EndIf

						Else
							ConsoleWrite(Chr(34) & $TempEXEWinTitle & Chr(34) & " found. Skipping" & @CRLF)
						EndIf
					EndIf
				Else
					ConsoleWrite("Ignoring LaunchProgram: " & $TempEXEWinTitle & @CRLF)
				EndIf
			Next
		EndIf
	EndIf
EndFunc   ;==>_LaunchPrograms

; Function for going through the priorities.
Func _PriorityCheck()
	If IsArray($PriorityArray) Then
		If $PriorityArray[0][0] > "0" Then
			; For every entry in the array...
			For $i = 1 To $PriorityArray[0][0]
				Local $PrioProcess = $PriorityArray[$i][0]
				If ProcessExists($PrioProcess) Then
					Local $PrioProcessSet = $PriorityArray[$i][1]
					Local $CurrentPrio = _ProcessGetPriority($PrioProcess)
					If $PrioProcessSet = "HIGH" And $CurrentPrio <> "4" Then
						ProcessSetPriority($PrioProcess, 4)
						ConsoleWrite("Changing priority on " & $PrioProcess & " from " & $CurrentPrio & " to 4 (High)." & @CRLF)
					ElseIf $PrioProcessSet = "NORMAL" And $CurrentPrio <> "2" Then
						ConsoleWrite("Changing priority on " & $PrioProcess & " from " & $CurrentPrio & " to 2 (Normal)." & @CRLF)
						ProcessSetPriority($PrioProcess, 2)
					ElseIf $PrioProcessSet = "LOW" And $CurrentPrio <> "0" Then
						ConsoleWrite("Changing priority on " & $PrioProcess & " from " & $CurrentPrio & " to 0. (Low)." & @CRLF)
						ProcessSetPriority($PrioProcess, 0)
					EndIf
					;ConsoleWrite($PrioProcess & " - " & $PrioProcessSet & " - " & $CurrentPrio & @CRLF)
				EndIf
			Next
		EndIf
	EndIf
EndFunc   ;==>_PriorityCheck

; Function for resetting headset
Func _ResetHeadSet()
	If $ResetHeadSet <> "" And $ResetHeadSet <> "NA" Then
		ConsoleWrite("Start ResetHeadSet using: <" & $ResetHeadSet & ">" & @CRLF)
		If $EnableSounds = "TRUE" and $VoiceResetHeadSet <> "NA" Then
			$Output = _Translate($VoiceResetHeadSet)
			If ProcessExists("ED_Speak.exe") Then
				ProcessClose("ED_Speak.exe")
			EndIf
			_Speak($Output)
			ProcessWaitClose("ED_Speak.exe",10); Wait until finished talking here.
			;ConsoleWrite("Voice: " & Chr(34) & $Output & Chr(34) & " to " & $CurrentlyActive & @CRLF)
			Sleep(500)
		Else
			If $DoubleClickGameWindowDelayTune = "TRUE" or $DoubleClickGameWindowDelayTune = "RESET" Then
				Beep(1000, 200)
				ConsoleWrite("_ResetHeadSet: Waiting one second after the beep." & @CRLF)
				Sleep(1000)
			EndIf
		EndIf

		WinActivate($EliteWindowTitle, "")
		Sleep(20)

		ConsoleWrite("Click key " & $ResetHeadSet & @CRLF)
		Send($ResetHeadSet)
		ConsoleWrite("End ResetHeadSet" & @CRLF)
	EndIf
EndFunc   ;==>_ResetHeadSet

Func _EnableNormalAudio()
	If $NoAutomaticAudioSwitching = "TRUE" And $ManualSwitched = "FALSE" Then
		ConsoleWrite("Not switching audio device. NoAutomaticAudioSwitching is TRUE and this was not a manual switch." & @CRLF)
	Else
		If ProcessExists("ED_Speak.exe") Then
			ProcessClose("ED_Speak.exe")
		EndIf
		RunWait("nircmd.exe setdefaultsounddevice " & Chr(34) & $NormalAudioDevice & Chr(34) & " 1")
		ConsoleWrite("Activating " & $NormalAudioDevice & ". Running nircmd.exe setdefaultsounddevice " & Chr(34) & $NormalAudioDevice & Chr(34) & " 1" & @CRLF)
		$CurrentlyActive = "Device2"

		If $VoiceNormalActive <> "NA" Then
			$Output = _Translate($VoiceNormalActive)
			_Speak($Output)
			;ConsoleWrite("Voice: " & Chr(34) & $Output & Chr(34) & " to " & $CurrentlyActive & @CRLF)
		EndIf
	EndIf
EndFunc   ;==>_EnableNormalAudio

Func _EnableVRAudio()
	If $NoAutomaticAudioSwitching = "TRUE" And $ManualSwitched = "FALSE" Then
		ConsoleWrite("Not switching audio device. NoAutomaticAudioSwitching is TRUE and this was not a manual switch." & @CRLF)
	Else
		If ProcessExists("ED_Speak.exe") Then
			ProcessClose("ED_Speak.exe")
		EndIf
		RunWait("nircmd.exe setdefaultsounddevice " & Chr(34) & $VRAudioDevice & Chr(34) & " 1")
		ConsoleWrite("Activating " & $VRAudioDevice & ". Running: nircmd.exe setdefaultsounddevice " & Chr(34) & $VRAudioDevice & Chr(34) & " 1" & @CRLF & @CRLF)
		$CurrentlyActive = "Device1"

		If $VoiceVRActive <> "NA" Then
			$Output = _Translate($VoiceVRActive)
			_Speak($Output)
			;ConsoleWrite("Voice: " & Chr(34) & $Output & Chr(34) & " to " & $CurrentlyActive & @CRLF)
		EndIf
	EndIf
EndFunc   ;==>_EnableVRAudio

Func _Translate($Output)
	$Output = StringReplace($Output, "<JoyID>", $JoyNum)
	$Output = StringReplace($Output, "<JoyMonitor>", $JoyMonitor)
	$Output = StringReplace($Output, "<JoyTolerance>", $JoyTolerance)
	$Output = StringReplace($Output, "<VRAudioDevice>", $VRAudioDevice)
	$Output = StringReplace($Output, "<NormalAudioDevice>", $NormalAudioDevice)
	$Output = StringReplace($Output, "<EliteWindowTitle>", $EliteWindowTitle)

	Return $Output
EndFunc   ;==>_Translate

;======================================
;   _JoyInit()
;======================================
Func _JoyInit()
	Local $joy
	Global $JOYINFOEX_struct = "dword[13]"

	$joy = DllStructCreate($JOYINFOEX_struct)
	If @error Then Return 0
	DllStructSetData($joy, 1, DllStructGetSize($joy), 1) ;dwSize = sizeof(struct)
	DllStructSetData($joy, 1, 255, 2) ;dwFlags = GetAll
	Return $joy
EndFunc   ;==>_JoyInit

;======================================
;   _GetJoy($lpJoy,$iJoy)
;   $lpJoy  Return from _JoyInit()
;   $iJoy   Joystick # 0-15
;   Return  Array containing X-Pos, Y-Pos, Z-Pos, R-Pos, U-Pos, V-Pos,POV
;           Buttons down
;
;           *POV This is a digital game pad, not analog joystick
;           65535   = Not pressed
;           0       = U
;           4500    = UR
;           9000    = R
;           Goes around clockwise increasing 4500 for each position
;======================================
Func _GetJoy($lpJoy, $iJoy)
	Local $coor, $ret
	;ConsoleWrite("_GetJoy: Checking joy " & $iJoy & @CRLF)
	Dim $coor[8]

	DllCall("Winmm.dll", "int", "joyGetPosEx", _
			"int", $iJoy, _
			"ptr", DllStructGetPtr($lpJoy))

	If Not @error Then
		$coor[0] = DllStructGetData($lpJoy, 1, 3)
		;ConsoleWrite("0: " & $coor[0] & @CRLF)
		$coor[1] = DllStructGetData($lpJoy, 1, 4)
		;ConsoleWrite("1: " & $coor[1] & @CRLF)
		$coor[2] = DllStructGetData($lpJoy, 1, 5)
		;ConsoleWrite("2: " & $coor[2] & @CRLF)
		$coor[3] = DllStructGetData($lpJoy, 1, 6)
		;ConsoleWrite("3: " & $coor[3] & @CRLF)
		$coor[4] = DllStructGetData($lpJoy, 1, 7)
		;ConsoleWrite("4: " & $coor[4] & @CRLF)
		$coor[5] = DllStructGetData($lpJoy, 1, 8)
		;ConsoleWrite("5: " & $coor[5] & @CRLF)
		$coor[6] = DllStructGetData($lpJoy, 1, 11)
		;ConsoleWrite("6: " & $coor[6] & @CRLF)
		$coor[7] = DllStructGetData($lpJoy, 1, 9)
		;ConsoleWrite("7: " & $coor[7] & @CRLF)
	EndIf

	Return $coor
EndFunc   ;==>_GetJoy

Func _Exit()
	While ProcessExists("ED_Speak.exe")
		ConsoleWrite("Exiting. Closing ED_Speak.exe to shut myself up." & @CRLF)
		ProcessClose("ED_Speak.exe")
		Sleep(10)
	Wend

	If FileExists(@TempDir & "\ED_Speak.exe") Then
		FileDelete(@TempDir & "\ED_Speak.exe")
	EndIf

	Exit
EndFunc   ;==>_Exit
