#NoTrayIcon
#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_Icon=..\Includes\EliteIcon.ico
#AutoIt3Wrapper_Outfile=Joystick_Test.exe
#AutoIt3Wrapper_UseX64=y
#AutoIt3Wrapper_Res_Description=Joystick Test 2.1.0
#AutoIt3Wrapper_Res_Fileversion=2.1.0.0
#AutoIt3Wrapper_Res_ProductVersion=2.1.0
#AutoIt3Wrapper_Res_LegalCopyright=Turranius (c) 2016-2018
#AutoIt3Wrapper_Run_Au3Stripper=y
#Au3Stripper_Parameters=/mo
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****

#include <Array.au3>
#include <ColorConstants.au3>
#include <GuiConstants.au3>
#include <Is_X64.au3>

#cs
	2.1 * Recreated GUI setup. Now a loop instead of a lot of repeating code.

	2.0 * Rewritten from scratch to show more than one controller.
#ce

If @Compiled Then
	Global $Version = FileGetVersion(@ScriptName)
	Global $Arch = _File_Is_X64(@ScriptName)
Else
	Global $Version = "Not compiled"
	Global $Arch = "Not compiled"
EndIf

Global $JoyNumEnd = 7
Global $CordsArray[8][$JoyNumEnd]; Create the array and make enough rows to hold all joysticks.
Global $JoyCoordsNow = "AnotherDummyValue"
Global $JoyCoordsOld = "DummyValue"
Dim $coor[8]

For $i = 0 to $JoyNumEnd
	Assign("NoChangeLoop" & $i, "0")
	Assign("JoyCoordsOld" & $i, "")
	Assign("ColorLabel" & $i, "")
Next

; Setup some joystick stuff
Local $joy, $coor, $h, $s, $msg
$joy = _JoyInit()

GUICreate('Joystick Tester for ED:Runner Version ' & $Version & " (" & $Arch & ")", 820, 260)

Local $LabelLocation=20
Local $DataLocation=60
Local $BackgroundLocation=15

For $g = 0 to $JoyNumEnd
	Assign("Label" & $g, GUICtrlCreateLabel('Controller ' & $g, $LabelLocation, 20, 100, 20))
	GUICtrlCreateLabel('0 X', $LabelLocation, 40, 100, 20)
	GUICtrlCreateLabel('1 Y', $LabelLocation, 60, 100, 20)
	GUICtrlCreateLabel('2 Z', $LabelLocation, 80, 100, 20)
	GUICtrlCreateLabel('3 R', $LabelLocation, 100, 100, 20)
	GUICtrlCreateLabel('4 U', $LabelLocation, 120, 100, 20)
	GUICtrlCreateLabel('5 V', $LabelLocation, 140, 100, 20)
	GUICtrlCreateLabel('6 POV', $LabelLocation, 160, 100, 20)
	GUICtrlCreateLabel('7 BTN', $LabelLocation, 180, 100, 20)
	Assign("Data" & $g & 0, GUICtrlCreateLabel('0', $DataLocation, 40, 100, 20))
	Assign("Data" & $g & 1, GUICtrlCreateLabel('0', $DataLocation, 60, 100, 20))
	Assign("Data" & $g & 2, GUICtrlCreateLabel('0', $DataLocation, 80, 100, 20))
	Assign("Data" & $g & 3, GUICtrlCreateLabel('0', $DataLocation, 100, 100, 20))
	Assign("Data" & $g & 4, GUICtrlCreateLabel('0', $DataLocation, 120, 100, 20))
	Assign("Data" & $g & 5, GUICtrlCreateLabel('0', $DataLocation, 140, 100, 20))
	Assign("Data" & $g & 6, GUICtrlCreateLabel('0', $DataLocation, 160, 100, 20))
	Assign("Data" & $g & 7, GUICtrlCreateLabel('0', $DataLocation, 180, 100, 20))
	GUICtrlCreateLabel("",$BackgroundLocation,15,90,185,$SS_SUNKEN)
	GUICtrlSetBkColor(-1, $GUI_BKCOLOR_TRANSPARENT)

	$LabelLocation = $LabelLocation + 100
	$DataLocation = $DataLocation + 100
	$BackgroundLocation = $BackgroundLocation + 100
Next

GUICtrlCreateLabel('If the numbers seems stuck on, say 32767, for a controller, try moving something on it or press a button to kickstart it.' _
& @CRLF & 'If you have a XBOX controller that does not react unless this program is in focus, read the \Xbox_Controller_Drivers\ReadMe.txt file.' _
& @CRLF & 'JoystickID in ED_Runner.ini can be defined as a single ID (IE: 0) or a range (IE: 0-2). A range must start with 0 though.' _
, 20, 210, 620, 320)

Global $idDonate = GUICtrlCreateButton("Donate", 650, 210, 80,40)
Global $idQuit = GUICtrlCreateButton("Quit", 730, 210, 80,40)

; Make all labels red
For $j = 0 to $JoyNumEnd
	GUICtrlSetColor(Eval("Label" & $j), $COLOR_RED)
Next

GUISetState()

While 1
	For $j = 0 to $JoyNumEnd

		;ConsoleWrite("Reading coords for joy " & $j & @CRLF)
		$coord = _GetJoy($joy, $j)
		$JoyCoordsNow = _ArrayToString($coord,",","0", "7")
;$JoyCoordsOld="0" ; Enable this one to not check if last value is the same as this one (fix for last connected controller showing as all the rest of them).

		; If the joycoordinates have not moved since last loop, do not update fields. No need.
		; Also, if the joycords are exactly the same as the last controller we checked, do not update either.
		If $JoyCoordsNow = Eval("JoyCoordsOld" & $j) or $JoyCoordsNow = $JoyCoordsOld Then
			Assign("NoChangeLoop" & $j, Eval("NoChangeLoop" & $j) + 1)
			;ConsoleWrite("Controller " & $j & " not changed in " & Eval("NoChangeLoop" & $j) & " loops" & @CRLF)
			If Eval("NoChangeLoop" & $j) > 50 Then
				If Eval("ColorLabel" & $j) <> "RED" Then
					Assign("ColorLabel" & $j, "RED")
					GUICtrlSetColor(Eval("Label" & $j), $COLOR_RED)
					For $i = 0 to 7
						GUICtrlSetColor(Eval("Data" & $j & $i), $CLR_DEFAULT)
					Next
				EndIf
				Assign("NoChangeLoop" & $j, 0)
			EndIf

		Else

			If Eval("ColorLabel" & $j) <> "GREEN" Then
			  Assign("ColorLabel" & $j, "GREEN")
			  GUICtrlSetColor(Eval("Label" & $j), $COLOR_GREEN)
			  Assign("NoChangeLoop" & $j, 0)
			EndIf

			If GuiCtrlRead(Eval("Data" & $j & "0")) <> $coord[0] Then
				GuiCtrlSetData(Eval("Data" & $j & "0"), $coord[0])
				GUICtrlSetColor(Eval("Data" & $j & "0"), $COLOR_GREEN)
			EndIf

			If GuiCtrlRead(Eval("Data" & $j & "1")) <> $coord[1] Then
				GuiCtrlSetData(Eval("Data" & $j & "1"), $coord[1])
				GUICtrlSetColor(Eval("Data" & $j & "1"), $COLOR_GREEN)
			EndIf

			If GuiCtrlRead(Eval("Data" & $j & "2")) <> $coord[2] Then
				GuiCtrlSetData(Eval("Data" & $j & "2"), $coord[2])
				GUICtrlSetColor(Eval("Data" & $j & "2"), $COLOR_GREEN)
			EndIf

			If GuiCtrlRead(Eval("Data" & $j & "3")) <> $coord[3] Then
				GuiCtrlSetData(Eval("Data" & $j & "3"), $coord[3])
				GUICtrlSetColor(Eval("Data" & $j & "3"), $COLOR_GREEN)
			EndIf

			If GuiCtrlRead(Eval("Data" & $j & "4")) <> $coord[4] Then
				GuiCtrlSetData(Eval("Data" & $j & "4"), $coord[4])
				GUICtrlSetColor(Eval("Data" & $j & "4"), $COLOR_GREEN)
			EndIf

			If GuiCtrlRead(Eval("Data" & $j & "5")) <> $coord[5] Then
				GuiCtrlSetData(Eval("Data" & $j & "5"), $coord[5])
				GUICtrlSetColor(Eval("Data" & $j & "5"), $COLOR_GREEN)
			EndIf

			If GuiCtrlRead(Eval("Data" & $j & "6")) <> $coord[6] Then
				GuiCtrlSetData(Eval("Data" & $j & "6"), $coord[6])
				GUICtrlSetColor(Eval("Data" & $j & "6"), $COLOR_GREEN)
			EndIf

			If GuiCtrlRead(Eval("Data" & $j & "7")) <> $coord[7] Then
				GuiCtrlSetData(Eval("Data" & $j & "7"), $coord[7])
				GUICtrlSetColor(Eval("Data" & $j & "7"), $COLOR_GREEN)
			EndIf

		EndIf

		Assign("JoyCoordsOld" & $j,$JoyCoordsNow); Save the values and compare on
		$JoyCoordsOld = $JoyCoordsNow
	Next

	Sleep(50)

	Switch GUIGetMsg()
		Case $idDonate
			Local $DonateResponse = MsgBox(68, "Donate for ED:Runner", "Donations are totally optional but any amount is very much appreciated." & @CRLF & @CRLF & "If you press Yes, a paypal link will open for a donation to eab@grandis.nu which is my public donation email. Please note that I can not respond to emails to that address. For that, try turranius@grandis.nu instead." & @CRLF & @CRLF & "Thank you!" & @CRLF & "/Turranius" & @CRLF & @CRLF & "Open donation link?")
			If $DonateResponse = 6 Then
				ShellExecute("https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=eab@grandis.nu&lc=US&item_name=Donation+for+ED+Runner&no_note=0&cn=&curency_code=USD&bn=PP-DonationsBF:btn_donateCC_LG.gif:NonHosted")
				GuiCtrlSetData($idDonate, "Aww ;)")
			Else
				GuiCtrlSetData($idDonate, "Aww ;(")
			EndIf

		Case $GUI_EVENT_CLOSE
			Exit

		Case $idQuit
			Exit
	EndSwitch
WEnd

;======================================
;   _JoyInit()
;======================================
Func _JoyInit()
    Local $joy
    Global $JOYINFOEX_struct    = "dword[13]"

    $joy=DllStructCreate($JOYINFOEX_struct)
    if @error Then Return 0
    DllStructSetData($joy, 1, DllStructGetSize($joy), 1);dwSize = sizeof(struct)
    DllStructSetData($joy, 1, 255, 2)              ;dwFlags = GetAll
    return $joy
EndFunc

;======================================
;   _GetJoy($lpJoy,$iJoy)
;   $lpJoy  Return from _JoyInit()
;   $iJoy   Joystick # 0-15
;   Return  Array containing X-Pos, Y-Pos, Z-Pos, R-Pos, U-Pos, V-Pos,POV
;           Buttons down
;
;           *POV This is a digital game pad, not analog joystick
;           65535   = Not pressed
;           0       = U
;           4500    = UR
;           9000    = R
;           Goes around clockwise increasing 4500 for each position

;======================================
Func _GetJoy($lpJoy, $iJoy)

	DllCall("Winmm.dll", "int", "joyGetPosEx", _
			"int", $iJoy, _
			"ptr", DllStructGetPtr($lpJoy))

	;ConsoleWrite("Status for " & $iJoy & ": " & @error & @CRLF)

	If Not @error Then
		$coor[0] = DllStructGetData($lpJoy, 1, 3)
		;ConsoleWrite("0: " & $coor[0] & @CRLF)
		$coor[1] = DllStructGetData($lpJoy, 1, 4)
		;ConsoleWrite("1: " & $coor[1] & @CRLF)
		$coor[2] = DllStructGetData($lpJoy, 1, 5)
		;ConsoleWrite("2: " & $coor[2] & @CRLF)
		$coor[3] = DllStructGetData($lpJoy, 1, 6)
		;ConsoleWrite("3: " & $coor[3] & @CRLF)
		$coor[4] = DllStructGetData($lpJoy, 1, 7)
		;ConsoleWrite("4: " & $coor[4] & @CRLF)
		$coor[5] = DllStructGetData($lpJoy, 1, 8)
		;ConsoleWrite("5: " & $coor[5] & @CRLF)
		$coor[6] = DllStructGetData($lpJoy, 1, 11)
		;ConsoleWrite("6: " & $coor[6] & @CRLF)
		$coor[7] = DllStructGetData($lpJoy, 1, 9)
		;ConsoleWrite("7: " & $coor[7] & @CRLF)
	EndIf

	Return $coor
EndFunc   ;==>_GetJoy
